#!/bin/sh

# This script is run by the user to cross-compile the uclibc based development
# environment used to create the final system.  (I.E. start here.)

# First, set up the environment to a known state.


# Create the temporary directory

if [ ! -f tmpdir/tools.img ]
then
  sources/scripts/0-make-tmpdir.sh &&
  sources/scripts/1-make-tools.sh
fi
if [ $? -eq 0 ]
then
  sources/scripts/2-make-firmware.sh
fi

echo -e "\033[0m=== Toolchain build script exiting."
